﻿Option Strict On
Option Infer On

Imports DirectShow

Public Class Form1
    Private WithEvents player As MediaPlayer

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        player.play()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        player.pause()
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        player.stop()
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        player.stop()
    End Sub

    Private Sub Form1_HandleCreated(sender As Object, e As EventArgs) Handles Me.HandleCreated
        player = New MediaPlayer
        player.handle = Panel1.Handle
    End Sub

    Private Sub Panel1_Resize(sender As Object, e As EventArgs) Handles Panel1.Resize
        If player IsNot Nothing Then player.resize(Panel1.ClientRectangle)
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Dim ofd As New OpenFileDialog
        If ofd.ShowDialog = Windows.Forms.DialogResult.OK Then
            player.mediaFile = ofd.FileName
        End If
    End Sub

    Private Sub TrackBar1_Scroll(sender As Object, e As EventArgs) Handles TrackBar1.Scroll
        player.Position = New TimeSpan(0, 0, 0, 0, TrackBar1.Value)
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As Object, e As EventArgs) Handles CheckBox1.CheckedChanged
        player.loop = CheckBox1.Checked
    End Sub

    Private Sub TrackBar2_Scroll(sender As Object, e As EventArgs) Handles TrackBar2.Scroll
        player.Volume = TrackBar2.Value
    End Sub

    Private Sub player_PositionChanged(sender As Object, e As EventArgs) Handles player.PositionChanged
        Me.BeginInvoke(Sub()
                           If player.State = MediaPlayerState.Stopped Then Exit Sub
                           TrackBar1.Value = CInt(player.Position.TotalMilliseconds)
                           Label1.Text = String.Join(" ", player.Position.ToString("hh\:mm\:ss"), "/", player.Length.ToString("hh\:mm\:ss"))
                       End Sub)
    End Sub

    Private Sub player_started(sender As Object, e As EventArgs) Handles player.started
        player.resize(Panel1.ClientRectangle)
        TrackBar1.Maximum = CInt(player.Length.TotalMilliseconds)
        TrackBar1.Value = 0
        Me.Text = "Media Player - " & IO.Path.GetFileNameWithoutExtension(player.MediaFile)
    End Sub

    Private Sub player_stopped(sender As Object, e As EventArgs) Handles player.stopped
        Me.BeginInvoke(Sub()
                           TrackBar1.Maximum = 0
                           TrackBar1.Value = 0
                           Label1.Text = "00:00:00 / 00:00:00"
                           Me.Text = "Media Player"
                       End Sub)
    End Sub
End Class
